package net.wanji.utc.cache;

import lombok.extern.slf4j.Slf4j;
import net.wanji.databus.po.CrossInfoPO;
import net.wanji.utc.websocket.WebSocketClientHandler;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.websocket.ContainerProvider;
import javax.websocket.Session;
import javax.websocket.WebSocketContainer;
import java.net.URI;
import java.util.List;

/**
 * @author duanruiming
 * @date 2024/01/10 17:28
 */
@Component
@Slf4j
@Order(2)
public class WebSocketClient implements CommandLineRunner {
    public static Session session;

    @Override
    public void run(String... args) throws Exception {
        try {
            if (WebSocketClient.session != null) {
                WebSocketClient.session.close();
            }
            WebSocketContainer container = ContainerProvider.getWebSocketContainer();
            List<CrossInfoPO> crossInfoList = CrossInfoCache.crossInfoList;
            if (!CollectionUtils.isEmpty(crossInfoList)) {
                for (CrossInfoPO crossInfoPO : crossInfoList) {
                    String crossId = crossInfoPO.getId();
                    String uri = "ws://localhost:32000/utc/signalStatus/" + crossId + ",preload";
                    session = container.connectToServer(WebSocketClientHandler.class, URI.create(uri));
                    log.info("ws客户端建立成功：[{}]", crossId);
                }
            }
        } catch (Exception e) {
            log.error("websocketClient初始化失败", e);
            throw new Exception(e);
        }
    }
}
